/**
 * @File
 *
 * Javascript client handler for nodejs checker.
 */

(function($) {
  var interval = false;
  var client = false;
  var server = false;
  Drupal.behaviors.nodejs_checker = {
    'attach': function(context, setting) {
      if (client == false && context == document) {
         interval = setInterval(Drupal.behaviors.nodejs_checker.check_server, 5000);
      }
    },

    'setClient' : function(state) {
      client = state;
      if (client == true) {
        server = true;
        Drupal.behaviors.nodejs_checker.killInterval();
      }
      else {
        interval = setInterval(Drupal.behaviors.nodejs_checker.check_server, 5000)
      }
    },

    'setServer' : function(state) {
      server = state;
      Drupal.behaviors.nodejs_checker.switchState(state);
    },

    'killInterval': function() {
      clearInterval(interval);
      interval = false;
    },

    'switchState': function(state) {
      if (state == false) {
        $('#nodejs_checker_server_state_disconnected').removeClass("nodejs_checker_hidden");
        $('#nodejs_checker_server_state_connected').addClass("nodejs_checker_hidden");
      }
      else {
        $('#nodejs_checker_server_state_disconnected').addClass("nodejs_checker_hidden");
        $('#nodejs_checker_server_state_connected').removeClass("nodejs_checker_hidden");
      }
    },

    'check_server' : function() {
      $.ajax({
        url: "/nodejs_checker",
        success: function(data) {
          Drupal.behaviors.nodejs_checker.setServer(data);
          if (client == true) {
            Drupal.behaviors.nodejs_checker.killInterval();
          }
        }
      });
    },

  };

  Drupal.Nodejs.connectionSetupHandlers.nodejs_checker = {
    'connect' : function() {
      $("#nodejs_checker_client_connected").removeClass("nodejs_checker_hidden");
      $("#nodejs_checker_client_disconnected").addClass("nodejs_checker_hidden");
      Drupal.behaviors.nodejs_checker.setClient(true);
    },
    'disconnect' : function() {
      $("#nodejs_checker_client_connected").addClass("nodejs_checker_hidden");
      $("#nodejs_checker_client_disconnected").removeClass("nodejs_checker_hidden");
      Drupal.behaviors.nodejs_checker.setClient(false);
    },
  };
})(jQuery);
